# RK3568 Release Note

## rk3568_bl32_v2.15.bin

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | :-------------------- | ----------- | -------- |
| 2024-10-31 | rk3568_bl32_v2.15.bin | 9f2aca7d1   | 重要     |

### New

1. 新增支持fw encrypt key的读写接口。

### Fixed

| Index | 重要程度 | 更新说明                        | 问题现象                                        | 问题来源 |
| ----- | -------- | ------------------------------- | ----------------------------------------------- | -------- |
| 1     | 重要     | 修正RSA OAEP MGF1算法           | TA在使用RSA算法OAEP MGF1填充方式会报错          | -        |
| 2     | 重要     | 修正secure boot是否使能判断条件 | 在硬件不稳定情况下可能错误认为开启了secure boot | -        |

------

## rk3568_ddr_{1560...1056}MHz_v1.23.bin

| 时间       | 文件                                  | 编译 commit | 重要程度 |
| ---------- | :------------------------------------ | ----------- | -------- |
| 2024-09-03 | rk3568_ddr_{1560...1056}MHz_v1.23.bin | 03ea844c5d  | 重要     |

### New

1. 增加DRAM类型探测顺序通过ddrbin_tool可配。
### Fixed

| Index | 重要程度 | 更新说明                                | 问题现象                                                  | 问题来源 |
| ----- | -------- | --------------------------------------- | --------------------------------------------------------- | -------- |
| 1     | 重要     | 修正DDR4概率性容量概率性探测失败的问题  | DDR4可能概率性的存在容量，ecc等探测出错                   | -        |
| 2     | 重要     | 增加支持ISSI UniIC 驱动偏弱的LP4/4x颗粒 | 解决ISSI UniIC LP4/4x因为驱动强度偏弱导致的稳定性较差问题 | -        |

------

## rk3568_bl32_v2.14.bin

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | :-------------------- | ----------- | -------- |
| 2024-09-02 | rk3568_bl32_v2.14.bin | 6c78a7d8    | 重要     |

### New

1. 支持软件TA加密密钥功能，客户可以不烧写密钥的情况下使用TA加密功能。
2. 支持 OTP hardware lock 功能，允许安全非安全OTP同时访问。
3. 支持 lock keyreader access 功能，提升安全性。

------

## rk3568_bl32_v2.13.bin

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | :-------------------- | ----------- | -------- |
| 2024-07-09 | rk3568_bl32_v2.13.bin | 7ab599eca   | 重要     |

### New

1. 其他安全性提升。
2. rpmb添加多次读取机制。
3. 增大MPI_MEMPOOL_SIZE。

------

## rk3568_ddr_{1560...1056}MHz_v1.22.bin

| 时间       | 文件                                  | 编译 commit | 重要程度 |
| ---------- | :------------------------------------ | ----------- | -------- |
| 2024-06-21 | rk3568_ddr_{1560...1056}MHz_v1.22.bin | f8ac117e9c  | 重要     |

### New

1. CLK/DQS slew rate支持高低频下配置不同值。
2. 增加颗粒Manufacturer ID打印。
3. DDR4开启LPASR以减小DDR4休眠功耗。

### Fixed

| Index | 重要程度 | 更新说明                           | 问题现象                                                     | 问题来源 |
| ----- | -------- | ---------------------------------- | ------------------------------------------------------------ | -------- |
| 1     | 重要     | DDR4 2cs下概率性training失败问题   | v1.21版本ddrbin引入的DDR4 2cs下概率性read/write training失败。 | -        |
| 2     | 重要     | LP4x 600M以下强制开启240ohm rx odt | 与个别颗粒存在低频rx odt disable下的兼容性问题，表现为324M不稳定 | -        |
| 3     | 重要     | 600MHz以下不做vref training        | v1.21版本ddrbin引入的vref training在低频下可能存在vref trining结果不可靠的问题。 | -        |

------

## rk3568_ddr_1560MHz_{D3_LP3,D3_LP4_4x}_eyescan_v1.22.bin

| 时间       | 文件                                                    | 编译 commit | 重要程度 |
| ---------- | :------------------------------------------------------ | ----------- | -------- |
| 2024-06-21 | rk3568_ddr_1560MHz_{D3_LP3,D3_LP4_4x}_eyescan_v1.22.bin | f8ac117e9c  | 重要     |

### New

1. 更新二维眼图打印格式。
2. 增加眼图margin自动判断。

------

## rk356x_spl_v1.14.bin

| 时间       | 文件                 | 编译 commit | 重要程度 |
| ---------- | -------------------- | ----------- | -------- |
| 2024-05-30 | rk356x_spl_v1.14.bin | 606f72bd97a  | 重要     |

### New

1. 增加rsa key hash掉电后继续烧写功能。

### Fixed

| Index | 重要程度 | 更新说明                                            | 问题现象                                                 | 问题来源 |
| ----- | -------- | --------------------------------------------------- | -------------------------------------------------------- | -------- |
| 1     | 重要     | 解决SPL下sd卡初始化失败 | SPL dts下没有打开pinctrl节点 | -        |

------

## rk3568_bl32_v2.12.bin

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | :-------------------- | ----------- | -------- |
| 2024-04-16 | rk3568_bl32_v2.12.bin | 185dc3c92   | 重要     |

### New

1. 增加输入参数检查，增加安全性。
2. 支持打印 TEE 内存占用信息。
3. 硬件 crypto 支持4G以上地址。
4. 支持打印 FWVER 信息。

------

## rk3568_ddr_{1560...920}MHz_v1.21.bin

| 时间       | 文件                               | 编译 commit | 重要程度 |
| ---------- | :--------------------------------- | ----------- | -------- |
| 2024-01-20 | rk3568_ddr_{1560...920}MHz_v1.21.bin | 2d653b3476 | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                                  | 问题现象                                              | 问题来源 |
| ----- | -------- | ----------------------------------------- | ----------------------------------------------------- | -------- |
| 1     | 重要     | 修正reboot时可能存在漏做CA training的问题 | reboot时可能有概率未做CA training。CA training结果为0 | -        |

------

## rk3568_ddr_{1560...920}MHz_v1.20.bin

| 时间       | 文件                               | 编译 commit | 重要程度 |
| ---------- | :--------------------------------- | ----------- | -------- |
| 2024-01-12 | rk3568_ddr_{1560...920}MHz_v1.20.bin | 77170a5e90 | 重要     |

### New

1. 可通过工具配置tRFC值。
2. 增加read/write vref training，提高读写稳定性。

### Fixed

| Index | 重要程度 | 更新说明                                                     | 问题现象                                      | 问题来源 |
| ----- | -------- | ------------------------------------------------------------ | --------------------------------------------- | -------- |
| 1     | 重要     | DDR ECC 使能时通过CPU提前访问来保证重启后pstore段memory的ECC正确性 | DDR ECC使能时重启后上一次开机的pstore信息丢失 | -        |
| 2     | 重要     | 更新DDR3/LPDDR3 rd/wr training码型提高读写信号余量           | 优化DDR3/LPDDR3读写信号余量                   | -        |
| 3     | 重要     | 修正6GB LPDDR3/4初始化失败问题                               | 6GB LPDDR3/4 初始化时卡住                     | -        |
| 4     | 重要     | LPDDR4/4X 780Mhz开启read odt，改善部分颗粒780MHz下稳定性     | 部分LPDDR4/4X颗粒780M下read稳定性较差         | -        |

------

## rk3568_pcie_v2.10.bin

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2023-12-18 | rk3568_pcie_v2.10.bin | 35f57cde3   | 普通     |

### New

1. Update the version。

------

## rk3568_pcie_v2.00.bin

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2023-12-06 | rk3568_pcie_v2.00.bin | I3e280b78   | 普通     |

### New

1. Fix bar capacity。

------

## rk3568_bl31_rt_v1.02.elf

| 时间       | 文件                     | 编译 commit | 重要程度 |
| ---------- | ------------------------ | ----------- | -------- |
| 2023-11-02 | rk3568_bl31_rt_v1.02.elf | 30c17915b   | 普通     |

### New

1. 支持通过atags配置l3 partition。

------

## rk3568_pcie_v1.00.bin

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2023-10-07 | rk3568_pcie_v1.00.bin | I01c2c7d7   | 普通     |

### New

1. 添加支持 pcie ep 初始化的裸系统可执行固件。

------

## rk3568_ddr_{1560...920}MHz_v1.19.bin

| 时间       | 文件                               | 编译 commit | 重要程度 |
| ---------- | :--------------------------------- | ----------- | -------- |
| 2023-09-11 | rk3568_ddr_{1560...920}MHz_v1.19.bin | fdeec6f4fc | 重要     |

### New

1. 增加RK3567支持。
2. RK3568增加LVDS1支持。

------

## rk3568_bl31_v1.44.elf

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2023-09-19 | rk3568_bl31_v1.44.elf | 8cea6ab0b   | 重要     |

### New

1. 增加RK3567芯片支持。

------

## rk356x_spl_v1.13.bin

| 时间       | 文件                 | 编译 commit | 重要程度 |
| ---------- | :------------------- | ----------- | -------- |
| 2023-09-25 | rk356x_spl_v1.13.bin | e4e124926e  | 重要     |

### New

1. 打印并传递固件版本号。

### Fixed

| Index | 重要程度 | 更新说明                                            | 问题现象                                                 | 问题来源 |
| ----- | -------- | --------------------------------------------------- | -------------------------------------------------------- | -------- |
| 1     | 重要     | 解决SPL加载校验u-boot.dtb失败后不加载备份镜像的问题 | 第一份uboot.img的u-boot.dtb损坏后，SPL没有加载备份镜像。 | -        |

------

## rk3568_bl32_v2.11.bin

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | :-------------------- | ----------- | -------- |
| 2023-08-28 | rk3568_bl32_v2.11.bin | b5340fd65   | 重要     |

### New

1. 默认设置伪随机数种子。
2. 内部TA支持读写security flag接口。
3. 内部TA支持判断  ta encryption key 是否写入。
4. 内部TA支持 toybrick ksn 接口。

### Fixed

| Index | 重要程度 | 更新说明                         | 问题现象             | 问题来源 |
| ----- | -------- | -------------------------------- | -------------------- | -------- |
| 1     | 重要     | 修正硬件crypto检查支持的算法列表 | 使用硬件crypto会报错 | -        |

------

## rk3568_bl31_cpu3_v1.01.elf

| 时间       | 文件                              | 编译 commit | 重要程度 |
| ---------- | --------------------------------- | ----------- | -------- |
| 2023-08-04 | rk3568_bl31_cpu3_v1.01.elf | b3d2ce25a   | 重要     |

### New

1. 基于最新bl31代码支持CPU3启动。

------

## rk3568_ddr_{1560...920}MHz_v1.18.bin

| 时间       | 文件                               | 编译 commit | 重要程度 |
| ---------- | :--------------------------------- | ----------- | -------- |
| 2023-07-17 | rk3568_ddr_{1560...920}MHz_v1.18.bin | f366f69a7d | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                            | 问题现象                                                     | 问题来源 |
| ----- | -------- | ----------------------------------- | ------------------------------------------------------------ | ------- |
| 1     | 重要 | 修正DDR active_ranks配置错误引起的休眠唤醒死机问题 | 休眠唤醒异常 | -       |

------

## rk3568_bl31_l3_part_ecc_v1.00.elf

| 时间       | 文件                              | 编译 commit | 重要程度 |
| ---------- | --------------------------------- | ----------- | -------- |
| 2023-06-20 | rk3568_bl31_l3_part_ecc_v1.00.elf | 6f31c2d8c   | 重要     |

### New

1. 初始版本：支持L3 cache分区和cache ECC。

------

## rk3568_ddr_{1056...324}MHz_v1.17.bin

| 时间       | 文件                               | 编译 commit | 重要程度 |
| ---------- | :--------------------------------- | ----------- | -------- |
| 2023-06-20 | rk3568_ddr_{1056...324}MHz_v1.17.bin | 992b933606 | 重要     |

### New

1. 增加不同row的4rank颗粒支持。
2. 增加DDR ECC poison功能支持。
3. 使能LPDDR4/LPDDR4x derate功能。
4. 增加ECC使能下的pstore支持。

------

## rk3568_bl32_v2.10.bin

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | :-------------------- | ----------- | -------- |
| 2023-06-07 | rk3568_bl32_v2.10.bin | dcfdd61d0   | 重要     |

### New

1. 支持关键OTP数据读取出错后从备份数据恢复。
2. crypto_service 支持地址参数安全性检查。
2. 支持内核读取安全启动标志和公钥哈希。
3. 支持动态共享内存，安全非安全世界可以传递更大数据。
4. BL32 打印支持 pstore，内核可以通过 pstore 节点查看 BL32 的打印信息。

------

## rk3568_bl31_v1.43.elf

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2023-06-05 | rk3568_bl31_v1.43.elf | bf602aff1   | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                            | 问题现象                                                     | 问题来源 |
| ----- | -------- | ----------------------------------- | ------------------------------------------------------------ | ------- |
| 1     | 重要     | 修复cpuidle进入bl31出现死锁的问题   | 系统概率性出现卡住一段时间(~30分钟)后恢复正常 | -       |

------

## rk3568_bl31_rt_v1.01.elf

| 时间       | 文件                     | 编译 commit | 重要程度 |
| ---------- | ------------------------ | ----------- | -------- |
| 2023-05-01 | rk3568_bl31_rt_v1.01.elf | b28ca126a   | 重要     |

### New

1. 支持通过OTP修改pvtpll配置。
2. 调整默认pvtpll配置，提高稳定性。

------

## rk3568_bl31_v1.42.elf

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2023-05-11 | rk3568_bl31_v1.42.elf | 7f859117f   | 重要     |

### New

1. 支持通过OTP修改pvtpll配置。
2. 调整默认pvtpll配置，提高稳定性。

------

## rk3568_bl31_v1.41.elf

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2023-05-06 | rk3568_bl31_v1.41.elf | e24c3f77b   | 普通     |

### Fixed

| Index | 重要程度 | 更新说明                            | 问题现象                                                     | 问题来源 |
| ----- | -------- | ----------------------------------- | ------------------------------------------------------------ | ------- |
| 1     | 普通   | 修改DDR ECC错误注入功能的smc_handler ID | DDR ECC错误注入功能异常失效 | -       |

------

## rk3568_bl31_rt_v1.00.elf

| 时间       | 文件                     | 编译 commit | 重要程度 |
| ---------- | ------------------------ | ----------- | -------- |
| 2023-05-04 | rk3568_bl31_rt_v1.00.elf | c3f2c8c3a   | 普通     |

### New

1. 优化实时系统的延迟。

------

## rk3568_ddr_1560MHz_eyescan_v1.16.bin

| 时间       | 文件                               | 编译 commit | 重要程度 |
| ---------- | :--------------------------------- | ----------- | -------- |
| 2023-04-19 | rk3568_ddr_1560MHz_eyescan_v1.16.bin | b9c108a4eb | 重要     |

### New

1. 增加RK3568 2D眼图扫描支持。

------

## rk3568_bl31_v1.40.elf

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2023-04-19 | rk3568_bl31_v1.40.elf | aef7950e4   | 普通     |

### New

1. 增加DDR ECC错误注入。

------

## rk356x_usbplug_v1.17.bin

| 时间       | 文件                     | 编译 commit | 重要程度 |
| ---------- | :----------------------- | ----------- | -------- |
| 2023-04-14 | rk356x_usbplug_v1.17.bin | 0661d5      | 普通     |

### New

1. 新增 spiflash 颗粒支持。

------

## rk3568_bl31_v1.39.elf

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2023-04-13 | rk3568_bl31_v1.39.elf | 0d745c7b1   | 重要     |

### New

1. 提高otp稳定性。

------

## rk3568_ddr_{1056...324}MHz_v1.16.bin

| 时间       | 文件                                 | 编译 commit | 重要程度 |
| ---------- | ------------------------------------ | ----------- | -------- |
| 2023-02-26 | rk3568_ddr_{1056...324}MHz_v1.16.bin | 6f71c736ce  | 重要     |

### New

1. LPDDR4/LPDDR4x模式默认使用derate功能。RK3568M，RK3568J在非LPDDR4/LPDDR4x模式下默认2倍刷新率。
2. 刷新率， pagecolse 可通过ddrbin_tool配置。
3. 提高ddr4效率。

### Fixed

| Index | 重要程度 | 更新说明                           | 问题现象                     | 问题来源 |
| ----- | -------- | ---------------------------------- | ---------------------------- | -------- |
| 1     | 重要     | 解决部分DDR4板子528M下的稳定性问题 | 部分DDR4在528M下容易死机     | -        |
| 2     | 重要     | 解决4GB ECC板子初始失败问题        | 4GB ECC板子ddr初始化阶段卡死 | -        |

------

## rk3568_bl31_v1.38.elf

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2023-02-16 | rk3568_bl31_v1.38.elf | 94b2d40dc   | 重要     |

### New

1. 提高sdei稳定性。

------

## rk3568_bl31_v1.37.elf

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2023-02-02 | rk3568_bl31_v1.37.elf | 1cd72fefa   | 重要     |

### New

1. 使能sdei。
2. 支持通过atags配置l3 partition。

------

## rk3568_ddr_{1560...324}MHz_v1.15.bin

| 时间       | 文件                                 | 编译 commit | 重要程度 |
| ---------- | ------------------------------------ | ----------- | -------- |
| 2022-11-08 | rk3568_ddr_{1560...324}MHz_v1.15.bin | ec2fae0c96  | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                               | 问题现象                                 | 问题来源 |
| ----- | -------- | -------------------------------------- | ---------------------------------------- | -------- |
| 1     | 重要     | 解决部分主控在DDR 324MHz下的不稳定问题 | 在DDR 324MHz下，系统不稳定，出现死机重启 | -        |

------

## rk3568_bl31_v1.36.elf

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | --------------------- | ----------- | -------- |
| 2022-11-08 | rk3568_bl31_v1.36.elf | 2c8be93f9   | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                               | 问题现象                                 | 问题来源 |
| ----- | -------- | -------------------------------------- | ---------------------------------------- | -------- |
| 1     | 重要     | 解决部分主控在DDR 324MHz下的不稳定问题 | 在DDR 324MHz下，系统不稳定，出现死机重启 | -        |

------

## rk356x_usbplug_v1.16.bin

| 时间       | 文件                     | 编译 commit | 重要程度 |
| ---------- | :----------------------- | ----------- | -------- |
| 2022-11-02 | rk356x_usbplug_v1.16.bin | eaaeb1      | 普通     |

### New

1. 新增 spiflash 颗粒支持。

------

## rk3568_bl31_v1.35.elf

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | :-------------------- | ----------- | -------- |
| 2022-10-24 | rk3568_bl31_v1.35.elf | cddd6f52e   | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                            | 问题现象                                                     | 问题来源 |
| ----- | -------- | ----------------------------------- | ------------------------------------------------------------ | ------- |
| 1     | 重要     | 解决休眠唤醒死机问题,PCIE休眠失败 | 在vdd_log休眠断电的情况下，GICR被复位，需要保存恢复GICR | -       |

------

## rk356{x_usbplug, 8_miniloader_spinand}_v1.15.bin

| 时间       | 文件                                             | 编译 commit | 重要程度 |
| ---------- | :----------------------------------------------- | ----------- | -------- |
| 2022-09-26 | rk356{x_usbplug, 8_miniloader_spinand}_v1.15.bin | 65048d1     | 普通     |

### New

1. 新增 spiflash 颗粒支持。

------

## rk3568_bl32_v2.09.bin

| 时间       | 文件                  | 编译 commit | 重要程度 |
| ---------- | :-------------------- | ----------- | -------- |
| 2022-09-16 | rk3568_bl32_v2.09.bin | d84087907   | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                            | 问题现象                                                     | 问题来源 |
| ----- | -------- | ----------------------------------- | ------------------------------------------------------------ | -------- |
| 1     | 重要     | 解决关闭打印时OPTEE启动阶段卡住问题 | 当用户使用/rkbin/tools/ddrbin_tool工具关闭打印时，rk_atags将通知OPTEE关闭打印，OPTEE启动时关闭打印会出现卡死，无法进入U-Boot | -        |

------

## rk3568_ddr_{1560...324}MHz_v1.14.bin

| 时间       | 文件                                 | 编译 commit | 重要程度 |
| ---------- | :----------------------------------- | ----------- | -------- |
| 2022-08-27 | rk3568_ddr_{1560...324}MHz_v1.14.bin | b1f29a2a6f  | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                            | 问题现象                                                     | 问题来源 |
| ----- | -------- | ----------------------------------- | ------------------------------------------------------------ | -------- |
| 1     | 重要     | 解决个别LPDDR4颗粒无法运行到1560MHz | 长鑫CXDB5CCAM-MK LPDDR4模式下1560MHz无法运行的问题，将CLK/CA sr改为0后ok。 | -        |
| 2     | 普通     | 解决部分颗粒timing设置错误问题      | t_xs_x32, t_xs_abort_x32 和t_xs_fast_x32这三个timing设置有误，其他平台上发现小容量颗粒(小于128M）上会引起异常。 | -        |
| 3     | 重要     | DDR4 528M稳定性问题                 | 个别颗粒528M下无法开启DLL，需要做关闭DLL处理.                | -        |
| 4     | 重要     | DDR4 1560M稳定性问题                | 部分2rank DDR4 PCB需要将DQS/DQ slew rate 加强到0x0才能稳定运行1560M | -        |

------

