# RV1126 Release Note

## rv1126_tee_ta_v2.14.bin

| 时间       | 文件                    | 编译 commit | 重要程度 |
| ---------- | :---------------------- | ----------- | -------- |
| 2024-10-31 | rv1126_tee_ta_v2.14.bin | 9f2aca7d1   | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                        | 问题现象                                        | 问题来源 |
| ----- | -------- | ------------------------------- | ----------------------------------------------- | -------- |
| 1     | 重要     | 修正RSA OAEP MGF1算法           | TA在使用RSA算法OAEP MGF1填充方式会报错          | -        |
| 2     | 重要     | 修正secure boot是否使能判断条件 | 在硬件不稳定情况下可能错误认为开启了secure boot | -        |

------

## rv1126_ddr_{1056 ... 784}MHz_v1.11.bin

| 时间       | 文件                                   | 编译 commit | 重要程度 |
| ---------- | -------------------------------------- | ----------- | -------- |
| 2024-10-11 | rv1126_ddr_{1056 ... 784}MHz_v1.11.bin | af45c23638  | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                 | 问题现象                                    | 问题来源 |
| ----- | -------- | ------------------------ | ------------------------------------------- | -------- |
| 1     | 重要     | 优化 DDR4 read gate 流程 | 部分特定型号的 DDR4 颗粒可能 read gate 异常 | -        |
| 2     | 重要     | 修正 DDR4 vref 写入流程  | DDR4 vref 不准确，可能导致稳定性问题        | -        |
| 3     | 重要     | 优化 DDR4 容量探测       | -                                           | -        |

------

## rv1126_tee_ta_v2.13.bin

| 时间       | 文件                    | 编译 commit | 重要程度 |
| ---------- | :---------------------- | ----------- | -------- |
| 2024-09-02 | rv1126_tee_ta_v2.13.bin | 6c78a7d8c   | 重要     |

### New

1. 支持软件TA加密密钥功能，客户可以不烧写密钥的情况下使用TA加密功能。
2. 使能动态共享内存，默认使用静态共享内存。
3. rpmb添加多次读取机制。
4. 增大MPI_MEMPOOL_SIZE。

------

## rv1126_tee_ta_v2.12.bin

| 时间       | 文件                    | 编译 commit | 重要程度 |
| ---------- | :---------------------- | ----------- | -------- |
| 2024-04-16 | rv1126_tee_ta_v2.12.bin | 185dc3c92   | 重要     |

### New

1. 增加输入参数检查，增加安全性。
2. 支持打印 TEE 内存占用信息。
3. 硬件 crypto 支持4G以上地址。

------

## rv1126_ddr_{1056 ... 784}MHz_v1.10.bin

| 时间       | 文件                                   | 编译 commit | 重要程度 |
| ---------- | -------------------------------------- | ----------- | -------- |
| 2024-04-10 | rv1126_ddr_{1056 ... 784}MHz_v1.10.bin | d69a0b90fd  | 紧急     |

### New

1. 增加otp的支持。
2. 增加 sram 的检查。

------

## rv1126_tee_v1.04.bin

| 时间       | 文件                 | 编译 commit | 重要程度 |
| ---------- | :------------------- | ----------- | -------- |
| 2024-03-07 | rv1126_tee_v1.04.bin | 796bbcbef   | 重要     |

### New

1. 优化休眠唤醒速度。

------

## rv1126_tee_ta_v2.11.bin

| 时间       | 文件                    | 编译 commit | 重要程度 |
| ---------- | :---------------------- | ----------- | -------- |
| 2023-10-07 | rv1126_tee_ta_v2.11.bin | 65a719aaa   | 重要     |

### New

1. 支持“唤醒后直接重启“的休眠唤醒模式。

------

## rv1126_spl_v1.10.bin

| 时间       | 文件                 | 编译 commit | 重要程度 |
| ---------- | :------------------- | ----------- | -------- |
| 2023-09-28 | rv1126_spl_v1.10.bin | e4e124926e  | 重要     |

### New

1. 打印并传递固件版本号。

### Fixed

| Index | 重要程度 | 更新说明                                            | 问题现象                                                 | 问题来源 |
| ----- | -------- | --------------------------------------------------- | -------------------------------------------------------- | -------- |
| 1     | 重要     | 解决SPL加载校验u-boot.dtb失败后不加载备份镜像的问题 | 第一份uboot.img的u-boot.dtb损坏后，SPL没有加载备份镜像。 | -        |

------

## rv1126_tee_ta_v2.10.bin

| 时间       | 文件                    | 编译 commit | 重要程度 |
| ---------- | :---------------------- | ----------- | -------- |
| 2023-08-29 | rv1126_tee_ta_v2.10.bin | b5340fd65   | 重要     |

### New

1. 内部TA支持读写security flag接口。
2. 内部TA支持判断  ta encryption key 是否写入。

------

## rv1126_tee_ta_v2.09.bin

| 时间       | 文件                    | 编译 commit | 重要程度 |
| ---------- | :---------------------- | ----------- | -------- |
| 2023-05-26 | rv1126_tee_ta_v2.09.bin | 59f324679   | 重要     |

### New

1. 支持内核读取安全启动标志和公钥哈希。

### Fixed

| Index | 重要程度 | 更新说明         | 问题现象                                    | 问题来源 |
| ----- | -------- | ---------------- | ------------------------------------------- | -------- |
| 1     | 重要     | 关闭动态共享内存 | 使用动态共享内存，运行CA TA应用会概率性失败 | -        |

------

## rv1126_usbplug_v1.24.bin

| 时间       | 文件                         | 编译 commit | 重要程度 |
| ---------- | :--------------------------- | ----------- | -------- |
| 2023-03-31 | rv1126_usbplug_v1.24.bin     | 0744719244  | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                 | 问题现象                | 问题来源 |
| ----- | -------- | ------------------------ | ----------------------- | -------- |
| 1     | 重要     | 解决OTP chip id 写错问题 | 空白片chip id写成rv1126 | -        |

------

## rv1126_spl_emmc_tb_v1.13.bin

| 时间       | 文件                         | 编译 commit | 重要程度 |
| ---------- | :--------------------------- | ----------- | -------- |
| 2022-12-09 | rv1126_spl_emmc_tb_v1.13.bin | f3f5db2e27  | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                    | 问题现象                        | 问题来源 |
| ----- | -------- | --------------------------- | ------------------------------- | -------- |
| 1     | 重要     | 解决decom使能标记位未清问题 | decom解压rootfs会提示decom busy | -        |

------

## rv1126_tee_ta_tb_v1.07.bin

| 时间       | 文件                       | 编译 commit | 重要程度 |
| ---------- | :------------------------- | ----------- | -------- |
| 2022-12-09 | rv1126_tee_ta_tb_v1.07.bin | 4eb6cbf6c   | 重要     |

### Fixed

| Index | 重要程度 | 更新说明            | 问题现象                                  | 问题来源 |
| ----- | -------- | ------------------- | ----------------------------------------- | -------- |
| 1     | 重要     | 解决fiq堆栈错误问题 | fiq模式下输入bt命令，会显示错误的堆栈信息 | -        |

------

## rv1126_ddr_{1056 ... 784}MHz_v1.09.bin

| 时间       | 文件                                   | 编译 commit | 重要程度 |
| ---------- | :------------------------------------- | ----------- | -------- |
| 2022-10-25 | rv1126_ddr_{1056 ... 784}MHz_v1.09.bin | 8fef64cfb9  | 紧急     |

### Fixed

| Index | 重要程度 | 更新说明                             | 问题现象                                                     | 问题来源 |
| ----- | -------- | ------------------------------------ | ------------------------------------------------------------ | -------- |
| 1     | 紧急     | 解决 LPDDR4X MRR 错误的问题          | MRR 函数中关于 LPDDR4X 的判断逻辑有缺陷，导致 LPDDR4X MRR 数据可能错误 | -        |
| 2     | 重要     | 解决部分 LPDDR4 颗粒 528MHz 报错问题 | 代码未考虑到少部分颗粒 Wr Lvl 结果可能会是负数，导致 Wr Lvl 结果判断可能出错 | 358198   |
| 3     | 普通     | 解决部分颗粒 timing 设置错误问题     | t_xs_x32、t_xs_abort_x32、t_xs_fast_x32 设置有误，其它平台上发现在小容量颗粒（小于128M）上会引起异常 | -        |
| 4     | 重要     | 解决部分 x32 LPDDR3 不稳定的问题     | LPDDR3 的探测流程有缺陷，导致部分 x32 LPDDR3 会被识别成 x16，进而导致部分 timing 配置错误 | 322844   |

------

## rv1126_tee_ta_v2.08.bin

| 时间       | 文件                    | 编译 commit | 重要程度 |
| ---------- | :---------------------- | ----------- | -------- |
| 2022-10-24 | rv1126_tee_ta_v2.08.bin | 317f8b06b   | 重要     |

### New

1. 支持pstore功能。

### Fixed

| Index | 重要程度 | 更新说明            | 问题现象                                  | 问题来源 |
| ----- | -------- | ------------------- | ----------------------------------------- | -------- |
| 1     | 重要     | 解决fiq堆栈错误问题 | fiq模式下输入bt命令，会显示错误的堆栈信息 | -        |

------

## rv1126_tee_ta_v2.07.bin

| 时间       | 文件                    | 编译 commit | 重要程度 |
| ---------- | :---------------------- | ----------- | -------- |
| 2022-09-16 | rv1126_tee_ta_v2.07.bin | d84087907   | 重要     |

### Fixed

| Index | 重要程度 | 更新说明                            | 问题现象                                                     | 问题来源 |
| ----- | -------- | ----------------------------------- | ------------------------------------------------------------ | -------- |
| 1     | 重要     | 解决关闭打印时OPTEE启动阶段卡住问题 | 当用户使用/rkbin/tools/ddrbin_tool工具关闭打印时，rk_atags将通知OPTEE关闭打印，OPTEE启动时关闭打印会出现卡死，无法进入U-Boot | -        |

------

## rv1126_{miniloader, usbplug}_ftl_v1.23.bin

| 时间       | 文件                                       | 编译 commit   | 重要程度 |
| ---------- | :----------------------------------------- | -------- | -------- |
| 2022-09-08 | rv1126_{miniloader, usbplug}_ftl_v1.23.bin | 55a904 | 普通     |

### New

1. 新增 SPI Nand 颗粒支持 MX35UF1GE4AD MX35UF2GE4AD。

------

